# $Id: cli.fr,v 1.22 2003/08/28 12:38:48 sdalu Exp $

##############################################################################
#                                                                            #
#             ===>   Localization files are UTF8 encoded   <===              #
#                                                                            #
##############################################################################

# 
# CONTACT     : zonecheck@nic.fr
# AUTHOR      : Stephane D'Alu <sdalu@nic.fr>
#
# CREATED     : 2002/08/02 13:58:17
# REVISION    : $Revision: 1.22 $ 
# DATE        : $Date: 2003/08/28 12:38:48 $
#
# CONTRIBUTORS: (see also CREDITS file)
#
#
# LICENSE     : GPL v2 (or MIT/X11-like after agreement)
# COPYRIGHT   : AFNIC (c) 2003
#
# This file is part of ZoneCheck.
#
# ZoneCheck is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# ZoneCheck is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with ZoneCheck; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#

input_cli_usage: \
usage: PROGNAME: [-hqV] [-voet opt] [-46] [-n ns...] [-c conf] nomdedomaine\n\
        --lang          Choisit une autre langue (en, fr, ...)\n\
    -d, --debug         Choisit les messages de deboguage à afficher\n\
    -h, --help          Affiche ce message\n\
    -V, --version       Affiche le numéro de version et quitte\n\
    -B, --batch         Mode en lots (lit depuis un fichier ou stdin '-')\n\
    -c, --config        Emplacement du fichier de configuration\n\
        --testdir       Emplacement du répertoire contenant les tests\n\
    -C, --category      Limite les tests à un ensemble de catégories\n\
    -T, --test          Nom du test à effectuer\n\
        --testlist      Liste tous les tests disponibles\n\
        --testdesc      Donne une description du test (name,expl,error)\n\
    -r, --resolver      Résolveur à utiliser pour déterminer les 'ns'\n\
    -n, --ns            Liste des serveurs de noms pour le domaine\n\
                           (ex: ns1;ns2=ip1,ip2;ns3=ip3)\n\
    -q, --quiet         N'affiche pas de titres suplémentaires\n\
    -1, --one           Affiche uniquement le message le plus significatif\n\
    -g, --tagonly       Affiche uniquement les tags (idéal pour les scripts)\n\
    -v, --verbose       Niveau de détail des informations (voir verbose)\n\
    -o, --output        Format de sortie (see output)\n\
    -e, --error         Comportement en cas d'erreur (voir error)\n\
    -t, --transp        Choix de la couche transport/routage (voir transp)\n\
    -4, --ipv4          Utilise uniquement IPv4 pour vérifier le domaine\n\
    -6, --ipv6          Utilise uniquement IPv6 pour vérifier le domaine\n\
        --option        Options supplémentaires (-,-opt,opt,opt=toto)\n\
\n\
  verbose:              [intro/testname/explain/details]\n\
                        [reportok|fatalonly] [testdesc|counter]\n\
    intro          [i]  Affiche un résumé du domaine et de ses serveurs\n\
    testname       [n]  Affiche le nom du test\n\
    explain        [x]  Affiche une explication en cas d'échec du test\n\
    details        [d]  Affiche les détails liés à l'échec du test\n\
    reportok       [o]  Affiche quand même les tests qui ont réussi\n\
    fatalonly      [f]  Affiche uniquement les erreurs fatales\n\
    testdesc       [t]  Affiche la description du test en cours\n\
    counter        [c]  Affiche une barre de progression\n\
\n\
  output:               [byseverity|byhost] [text|html]\n\
    byseverity    *[bs] Affiche les résultats classés par sévérité\n\
    byhost         [bh] Affiche les résultats classés par machine\n\
    text          *[t]  Formatage en texte pur\n\
    html           [h]  Formatage en HTML\n\
\n\
  error:                [allfatal|allwarning|dfltseverity] [stop|nostop]\n\
    allfatal       [af] Tout échec est considéré comme fatal\n\
    allwarning     [aw] Tout échec est considéré comme un avertissement\n\
    dfltseverity  *[ds] Utilise la sévérité associée au test\n\
    stop          *[s]  Arrête dès le premier échec\n\
    nostop         [ns] Exécute tous les tests (même après échec fatal)\n\
\n\
  transp:               [ipv4/ipv6] [udp|tcp|std]\n\
    ipv4          *[4]  Utilise le protocole de routage IPv4\n\
    ipv6          *[6]  Utilise le protocole de routage IPv6\n\
    udp            [u]  Utilise la couche de transport UDP\n\
    tcp            [t]  Utilise la couche de transport TCP\n\
    std           *[s]  Utilise UDP et se replie sur TCP si nécessaire\n\
\n\
  Traitement en lots:\n\
   Lit les domaines ligne par ligne depuis un fichier ou l'entrée standard,\n\
   La syntaxe est:\n\
      DOM=nom_de_domain\n\
   ou DOM=nom_de_domain NS=ns1;ns2=ip1,ip2\n\
\n\
  Catégories:\n\
    permet=[+|]    interdit=[-|!]    sous-composant=:    séparateur=,\n\
    ex: dns:soa,!dns,+\n\
        n'effectue pas les tests DNS qui ne sont pas liés au SOA\n\
\n\
\n\
EXEMPLES:\n\
  PROGNAME -6 --verbose=i,x,d afnic.fr.\n\
    Teste le domaine 'afnic.fr.' en utilisant uniquement une connectivité\n\
    IPv6, affiche un résumé des informations sur le domaine testé\n\
    ainsi qu'une explication et les détails sur les tests ayant échoués\n\
\n\
  PROGNAME -v c -1 -B -\n\
    Travail en mode par lots, où les domaines sont lus depuis l'entrée\n\
    standard, une barre de progression indique combien de tests restent,\n\
    et uniquement un court rapport est rédigé\n\
\n\
  PROGNAME --testdesc error -T chk_soa\n\
    Demande le message 'error' associé avec le test 'chk_soa'\n
