# $Id: generic.fr,v 1.14 2003/06/09 19:36:44 sdalu Exp $

##############################################################################
#                                                                            #
#             ===>   Localization files are UTF8 encoded   <===              #
#                                                                            #
##############################################################################

# 
# CONTACT     : zonecheck@nic.fr
# AUTHOR      : Stephane D'Alu <sdalu@nic.fr>
#
# CREATED     : 2002/08/02 13:58:17
# REVISION    : $Revision: 1.14 $ 
# DATE        : $Date: 2003/06/09 19:36:44 $
#
# CONTRIBUTORS: (see also CREDITS file)
#
#
# LICENSE     : GPL v2 (or MIT/X11-like after agreement)
# COPYRIGHT   : AFNIC (c) 2003
#
# This file is part of ZoneCheck.
#
# ZoneCheck is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# ZoneCheck is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with ZoneCheck; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#

[*]
label_xpl : [ref]: IETF RFC1034 (p.11)\nLabels are only composed by letters ([A-Za-z]), digits ([0-9]) or dashes\n('-') (not starting or ending with), and should be less than 63 characters;\ndomain name (labels separated by '.') should be less than 255 characters.\nSee also [ref]: IETF RFC1912 (2.1 Inconsistent, Missing, or Bad Data).

xpl_rfc2182 : [adv]: AFNIC\nTo avoid loosing all connectivity with the autoritative DNS in case\n of network outage it is advised to host the DNS on different networks.\nSee also IETF RFC2182.\n[ref]: IETF RFC2182 (Abstract)\nThe Domain Name System requires that multiple servers exist for every\ndelegated domain (zone).  This document discusses the selection of\nsecondary servers for DNS zones.  Both the physical and topological\nlocation of each server are material considerations when selecting\nsecondary servers.  The number of servers appropriate for a zone is\nalso discussed, and some general secondary server maintenance issues\nconsidered.



[chk_dn_sntx]
testname: nom de domaine contenant des caractères illégaux
error   : Le nom de domaine contient des caractères illégaux
ok	: Le nom de domaine ne contient aucun caractère illégal
explain = label_xpl


[chk_dn_orp_hyph]
testname: tiret ('-') au début ou à la fin du nom de domaine
error   : Le nom de domaine commence ou finit par un tiret ('-')
ok	: Aucune mauvaise utilisation du tiret ('-') dans le nom de domaine
explain = label_xpl


[chk_dn_dbl_hyph]
testname: double tiret ('--') dans le nom de domaine
error   : Le nom de domaine contient un double tiret ('--')
ok	: Pas d'utilisation du double tiret ('--')
explain : [ref]: IETF IDN project (internationalized domain names)\nThe double dash ('--') will have a special meaning for the domain name\nencoding, so it is strongly advised not to used it. See \n<URL:http://www.iana.org/cctld/specifications-policies-cctlds-01apr02.htm> (4. Tagged Domain Names.)


[chk_one_ns]
testname: présence de serveurs de nom gérant le domaine
error   : Au moins un serveur de nom est requis
ok	: Au moins un serveur de nom présent
explain = xpl_rfc2182


[chk_several_ns]
testname: présence d'au moins deux serveurs de noms pour le domaine
error   : Au moins deux serveurs de noms sont nécessaires
ok	: Au moins deux serveurs de noms présents
explain = xpl_rfc2182


[chk_ip_distinct]
testname: adresses IP identiques parmi les serveurs
error   : Toutes les adresses IP doivent être distinctes
ok	: Toutes les adresses IP sont distinctes
explain = xpl_rfc2182
details : Les serveurs de noms %{ns} utilisent la même adresse IP (%{ip}).


[chk_ip_same_net]
testname: serveurs de noms sur le même sous réseau
error   : Des serveurs sont sur le même sous réseau
ok	: Aucun serveur de nom n'est sous le même sous réseau
explain = xpl_rfc2182
details : Les sous réseaux suivants sont utilisés par plusieurs hôtes: %{subnets}. Essayez de déplacer certains hôtes sur un autre sous réseau.


[chk_ip_all_same_net]
testname: serveurs de noms tous sur le même sous réseau
error   : Les serveurs de noms sont tous sur le même sous réseau
ok	: Les serveurs de noms ne sont pas tous sur le même sous réseau
explain = xpl_rfc2182
details : Tous les serveurs de noms sont dans le sous réseau %{subnet}. Essayez d'en déplacer quelques uns sur un autre sous réseau.
