# $Id: soa.fr,v 1.21 2003/07/22 08:51:27 sdalu Exp $

##############################################################################
#                                                                            #
#             ===>   Localization files are UTF8 encoded   <===              #
#                                                                            #
##############################################################################

# 
# CONTACT     : zonecheck@nic.fr
# AUTHOR      : Stephane D'Alu <sdalu@nic.fr>
#
# CREATED     : 2002/08/02 13:58:17
# REVISION    : $Revision: 1.21 $ 
# DATE        : $Date: 2003/07/22 08:51:27 $
#
# CONTRIBUTORS: (see also CREDITS file)
#
#
# LICENSE     : GPL v2 (or MIT/X11-like after agreement)
# COPYRIGHT   : AFNIC (c) 2003
#
# This file is part of ZoneCheck.
#
# ZoneCheck is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# ZoneCheck is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with ZoneCheck; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#

[*]
xpl_email_sntx: [ref]: IETF RFC1034 (p.9), RFC1912 (p.3)\nEmail addresses are converted by using the following rule:\n   <local-part>@<mail-domain>  ==>  <local-part>.<mail-domain>\nif <local-part> contains a dot in should be backslashed (for 'bind')

[chk_soa]
testname: présence d'un enregistrement SOA
error   : Aucun enregistrement SOA présent sur le serveur
ok	: Enregistrement SOA trouvé
explain : [none]


[chk_soa_auth]
testname: réponse faisant autorité pour le SOA
error   : La réponse pour le SOA ne fait pas autorité
ok	: La réponse pour le SOA fait autorité
explain : [none]


[chk_soa_contact_sntx_at]
testname: mauvaise utilisation du caractère '@' dans le 'contact' du SOA
error   : Le contact contient le caractère '@'
ok	: Aucune mauvaise utilisation du caractere '@' dans le 'contact' du SOA
explain = xpl_email_sntx


[chk_soa_contact_sntx]
testname: caractères illégaux dans le contact du SOA
error   : Le contact contient des caractères illégaux
ok	: Aucun caractère illégal dans le contact du SOA
explain = xpl_email_sntx


[chk_soa_master_sntx]
testname: caractères illégaux dans le 'master' du SOA
error   : Le 'master' du SOA contient des caractères illégaux
ok	: Aucun caractère illégal dans le 'master' du SOA
explain = label_xpl


[chk_soa_master_fq]
testname: nom de serveur pleinement qualifié dans le 'master' du SOA
error   : Le nom du serveur dans le 'master' du SOA n'est pas pleinement qualifié
ok	: Le 'master' est pleinement qualifié
explain : [none]
details : Le point ('.') final est certainement manquant dans le fichier de configuration pour le serveur (%{mname}) indiqué en tant que maître dans le SOA.


[chk_soa_serial_fmt_YYYYMMDDnn]
testname: numéro de série de la forme AAAAMMJJnn
error   : Le numéro de série n'est pas de la forme AAAAMMJJnn
ok	: Le numéro de série suit bien la forme AAAAMMJJnn
explain : [ref]: RFC1912 (p.3)\nThe recommended syntax is YYYYMMDDnn (YYYY=year, MM=month, DD=day,\nnn=revision number).
details : Le numéro de série %{serial} ne semble pas être au format YYYYMMDDnn.


[chk_soa_refresh_6h]
testname: champ 'refresh' du SOA est à au moins 6 heures
error   : Le champ 'refresh' doit être positionné à au moins 6 heures
ok	: Le champ 'refresh' du SOA est à au moins 6 heures
explain : [ref]: RFC1912 (p.3) et RIPE-203
details : La valeur du champ 'refresh' est de %{refresh} sec, et devrait être de au moins 6 heures (21600 sec).


[chk_soa_retry_refresh]
testname: champ 'retry' du SOA inférieur à celui du 'refresh'
error   : Le champ 'retry' doit être inférieur à celui du 'refresh'
ok	: Le champ 'retry' du SOA inférieur à celui du 'refresh'
explain : [ref]: IETF RFC1912 (p.4)\nThe 'retry' value is typically a fraction of the 'refresh' interval.
details : La valeur du champ 'retry' est de %{retry} sec, et devrait être inférieure au 'refresh' (%{refresh} sec).


[chk_soa_retry_1h]
testname: champ 'retry' du SOA est d'au moins 1 heure
error   : Le champ 'retry' doit être d'au moins 1 heure
ok	: Le champ 'retry' du SOA est d'au moins 1 heure
explain : [ref]: RFC1912 (p.3) et RIPE-203
details : La valeur du champ 'retry' est de %{retry} sec, et devrait être d'au moins 1 heure (3600 sec).


[chk_soa_expire_7d]
testname: champ 'expire' du SOA est d'au moins 7 jours
error   : Le champ 'expire' doit être d'au moins 7 jours
ok	: Le champ 'expire' du SOA est d'au moins 7 jours
explain : [ref]: IETF RFC1912 (p.4)\nAfter a zone is expired a secondary will still continue to try to contact\nthe primary, but it will no longer provide nameservice for the zone.\n2 to 4 weeks are suggested values.\n[ref]: AFNIC constraint\nA minimum of 1 week (7 days) is enforced.
details : La valeur du champ 'expire' est de %{expire} sec, et devrait être d'au moins 7 jours (604800 sec).


[chk_soa_expire_7refresh]
testname: champ 'expire' est au moins 7 fois celui du 'refresh'
error   : Le champ 'expire' doit être au moins 7 fois celui du 'refresh'
ok	: Le champ 'expire' est au moins 7 fois celui du 'refresh'
explain : [none]
details : La valeur du champ 'expire' est de %{expire} sec, et devrait être 7 fois plus grande que celle du 'refresh' (%{refresh} sec).


[chk_soa_minimum_1d]
testname: champ 'minimum' du SOA inférieur à 1 jour
error   : Le champ 'minimum' doit être inférieur à 1 jour
ok	: Le champ 'minimum' du SOA est inférieur à 1 jour
explain : [ref]: RFC2308 (p.9) 5. Caching Negative Answers\nValues of one to three hours have been found to work well\nand would make sensible a default.  Values exceeding one day have\nbeen found to be problematic.
details : La valeur du champ 'minimum' est de %{minimum} sec, et devrait être moins de 1 jour (86400 sec), la valeur recommandée est entre 1 et 3 heures.


[chk_soa_ns_cname]
testname: champ 'master' du SOA n'est pas un alias
error   : Le champ 'master' du SOA ne doit pas pointer sur un alias CNAME
ok	: Le champ 'master' du SOA n'est pas un alias
explain = ns_cname_xpl
details : Le serveur maître (%{master}) indiqué dans le SOA est un alias CNAME sur %{alias}.


[chk_soa_vs_any]
testname: cohérence entre enregistrements SOA et ANY
error   : Enregistrements SOA et ANY incohérents
ok	: Enregistrements SOA et ANY cohérents
explain : [none]


[chk_soa_coherence_serial]
testname: cohérence du numéro de série avec celui du serveur primaire
error   : Le numéro de série n'est pas cohérent avec celui du serveur primaire
ok	: Le numéro de série est cohérent avec celui du serveur primaire
explain : [none]
details : Le numéro de série obtenu (%{serial_this}) est différent de celui indiqué sur %{host_ref} (%{serial_ref}).


[chk_soa_coherence_contact]
testname: cohérence du contact administratif avec celui du serveur primaire
error   : Le contact n'est pas cohérent avec celui du serveur primaire
ok	: Le contact est cohérent avec celui du serveur primaire
explain : [none]
details : Le contact obtenu (%{rname_this}) est différent de celui indiqué sur %{host_ref} (%{rname_ref}).


[chk_soa_coherence_master]
testname: cohérence du champ 'master' du SOA avec celui du serveur primaire
error   : Le champ 'master' du SOA est incohérent avec celui du serveur primaire
ok	: Le champ 'master' du SOA est cohérent avec celui du serveur primaire
explain : [none]
details : Le serveur maître indiqué dans le SOA (%{mname_this}) est différent de celui indiqué sur %{host_ref} (%{mname_ref}).
